function varargout = Command_window(varargin)
%Pantalla per executar comandes al terminal de matlab. Util especialment en
%les versions compilades de la toolbox. 
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Command_window();
%

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Command_window_OpeningFcn, ...
                   'gui_OutputFcn',  @Command_window_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Command_window_OpeningFcn(hObject, ~, handles, varargin)
%output function !
handles.output = hObject;
handles=menu(handles);
guidata(hObject, handles);

x=evalc('evalin(''base'',''whos()'')');
if isempty(x)
    x={''};
else
    x=textscan(x,'%s','Delimiter','\n');
end
set(handles.listbox2,'String',x{1});
set(handles.listbox2,'Value',length(get(handles.listbox2,'String')));

function varargout = Command_window_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;

function listbox1_Callback(~, ~, ~)

function listbox1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit1_Callback(~, ~, handles)
try
    if strcmp(get(handles.edit1,'String'),'clc') || strcmp(get(handles.edit1,'String'),'clc;')
         set(handles.listbox1,'String',[])
    else
        x=evalc('evalin(''base'',get(handles.edit1,''String''))');
        anterior=get(handles.listbox1,'String');
        if isempty(x)
            x={''};
        else
            x=textscan(x,'%s','Delimiter','\n');
            
        end
        set(handles.listbox1,'String',[anterior; {['>>' get(handles.edit1,'String')]}; x{1}(2:(length(x{1})-1))]);
        set(handles.listbox1,'Value',length(get(handles.listbox1,'String')));
        Update_Caller();
    end
catch err
    %mostrem l'error
    anterior=get(handles.listbox1,'String');

    if isempty(anterior)
        set(handles.listbox1,'String',[ {};'>>' get(handles.edit1,'String') ;'??? ' err.message]);%x{1}]);
    else
        set(handles.listbox1,'String',[anterior; '>>' get(handles.edit1,'String') ;'??? ' err.message]);%x{1}]);
    end
    set(handles.listbox1,'Value',length(get(handles.listbox1,'String')));
    
end

function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function listbox2_Callback(~, ~, ~)

function listbox2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function figure1_ResizeFcn(hObject, ~, handles)
pos=get(hObject,'Position');
set(handles.listbox1,'Position',[1 4 pos(3)*0.75-1 pos(4)-5]);
set(handles.listbox2,'Position',[pos(3)*0.75+1 4 pos(3)*0.25-2 pos(4)-5]);
set(handles.edit1,'Position',[1 1 pos(3)-2 2]);

function Update(hObject, ~, handles)
handles.output = hObject;
handles=menu(handles);
guidata(hObject, handles);

x=evalc('evalin(''base'',''whos()'')');
if isempty(x)
    x={''};
else
    x=textscan(x,'%s','Delimiter','\n');
end
set(handles.listbox2,'String',x{1});
set(handles.listbox2,'Value',length(get(handles.listbox2,'String')));

function Comanda(hObject,eventdata,handles,inst)
%funci per rebre comandes des de l'exterior. inst es un string
%corresponent a la comanda que volen evaluar.

set(handles.edit1,'String',inst);%posem la instruccio que volem evaluar
edit1_Callback(hObject, eventdata, handles);%la evaluem!
