function varargout = Menu_Canvia_Lots(varargin)
%Pantalla que permet canviar lots d'un objecte DATa a un altre, accedr a
%certs grafics per representar les dades contingudes en aquests objectes i
%modificar-ne els noms o classes dels lots.
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Canvia_Lots();
%

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Canvia_Lots_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Canvia_Lots_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_Canvia_Lots_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.
handles.output = hObject;
handles=menu(handles);

guidata(hObject, handles);

%busquem objectes dades
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
       list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA obsects in workspace'};
end
set(handles.popupmenu1,'String',list);
%tambe posem la llista al popupmenu2!
set(handles.popupmenu2,'String',list);

set(handles.listbox1,'Max',999999);
set(handles.listbox2,'Max',999999);

function pushbutton3_Callback(~, ~, handles)
%comprobem que hi hagi lots seleccionats
if isempty(get(handles.listbox2,'String'))
    errordlg('You must select one object!','Error');

else
    
    %nom de l'objecte dades2
    dade=get(handles.popupmenu2,'String');
    dade=dade{get(handles.popupmenu2,'Value')};
    
    
    %treiem tots els lots!
    inst=[  dade '.deleteBatch(1:' num2str(evalin('base',[dade '.getBatchCount()'])) ');'];
    evalin('base',inst);
    
    %actualitzem la llista dels lots
    aux=evalin('base',[dade '.getBatchLabel()']);
    set(handles.listbox2,'String', aux);
    set(handles.listbox2,'Value',length(aux));
    
    dad=get(handles.popupmenu1,'String');
    dad=dad{get(handles.popupmenu1,'Value')};
    if strcmp(dade,dad)
        set(handles.listbox1,'String', aux);
        set(handles.listbox1,'Value',length(aux));
    end
end

function popupmenu2_Callback(~, ~, handles)
%nom de l'objecte dades2 
dade=get(handles.popupmenu2,'String');
dade=dade{get(handles.popupmenu2,'Value')};


%actualitzem la llista dels lots
aux=evalin('base',[dade '.getBatchLabel()']);

%si no te noms de lot els generem asignant-hi la posicio actual del lot!!
if(isempty(aux) && (evalin('base',[dade '.getBatchCount()']) > 0))
    evalin('base',[dade '.setBatchLabel(num2cell(1:' dade '.getBatchCount))']);
    warndlg('Selected object had no batch names. Automatic ones ware assigned.','Attention!')

    aux=evalin('base',[dade '.getBatchLabel()']);
end

set(handles.listbox2,'String',aux);
set(handles.listbox2,'Value',1);
set(handles.listbox2,'ListboxTop', 1);

function popupmenu1_Callback(~, ~, handles)
%nom de l'objecte dades1 
dade=get(handles.popupmenu1,'String');
dade=dade{get(handles.popupmenu1,'Value')};


%actualitzem la llista dels lots
aux=evalin('base',[dade '.getBatchLabel()']);

%si no te noms de lot els generem asignant-hi la posicio actual del lot!!
if(isempty(aux) && (evalin('base',[dade '.getBatchCount()']) > 0))
    evalin('base',[dade '.setBatchLabel(num2cell(1:' dade '.getBatchCount))']);
    warndlg('Selected object had no batch names. Automatic ones ware assigned.','Attention!')

    aux=evalin('base',[dade '.getBatchLabel()']);
end
set(handles.listbox1,'String',aux);
set(handles.listbox1,'Value',1);
set(handles.listbox1,'ListboxTop', 1);

function pushbutton4_Callback(~, ~, handles)
%comprobem que hi hagi lots seleccionats
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');

else
    
    %nom de l'objecte dades1
    dade=get(handles.popupmenu1,'String');
    dade=dade{get(handles.popupmenu1,'Value')};
    
    
    %treiem tots els lots!
    inst=[  dade '.deleteBatch( 1:' num2str(evalin('base',[dade '.getBatchCount()'])) ' );'];
    evalin('base',inst);
    
    %actualitzem la llista dels lots
    aux=evalin('base',[dade '.getBatchLabel()']);
    set(handles.listbox1,'String', aux);
    set(handles.listbox1,'Value',length(aux));
    
    dad=get(handles.popupmenu2,'String');
    dad=dad{get(handles.popupmenu2,'Value')};
    if strcmp(dade,dad)
        set(handles.listbox2,'String', aux);
        set(handles.listbox2,'Value',length(aux));
    end
end

function pushbutton5_Callback(~, ~, ~)
uiwait(Menu_Load_Dades());

function Update(hObject, ~, handles) 
handles.output = hObject;
handles=menu(handles);

%Tornem a crear la llista d'objectes DATA
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
        list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA obsects in workspace'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};

nom2=get(handles.popupmenu2,'String');
nom2=nom2{get(handles.popupmenu2,'Value')};

%busquem aquest nom entre la llista actual
val=find(strcmp(nom,list));

%posem la nova llista de noms
set(handles.popupmenu1,'String',list);
set(handles.popupmenu2,'String',list);
if isempty(val)
    set(handles.popupmenu1,'Value',1);
    %i desactivem els menus!
set(handles.listbox1,'String',[]);
set(handles.listbox1,'value',1);
    
else
    set(handles.popupmenu1,'Value',val);
end


%busquem aquest nom entre la llista actual
val=find(strcmp(nom2,list));
if isempty(val)
    set(handles.popupmenu2,'Value',1);
    %i desactivem els menus!
set(handles.listbox2,'String',[]);
set(handles.listbox2,'value',1);
    
else
    set(handles.popupmenu2,'Value',val);
end

guidata(hObject, handles);

function pushbutton7_Callback(~, ~, handles)
%comprovem que hi hagi algun lot seleccionat
if isempty(get(handles.listbox2,'String')) || isempty(get(handles.listbox1,'String'))
    errordlg('Select at least one object!','Error');

else
    
    %nom de l'objecte dades que s'esta mostran al list dreta
    dade=get(handles.popupmenu2,'String');
    dade1=dade{get(handles.popupmenu2,'Value')};
    
 
    %nom de l'objecte dades que s'esta mostran al list esquerre
    dade=get(handles.popupmenu1,'String');
    dade2=dade{get(handles.popupmenu1,'Value')};
    
    
    
    %L'element seleccionat a la dreta
    lot=get(handles.listbox2,'Value');%la posici del lot!
    inst=[ dade1 '.getBatch([' num2str(lot) ']);'];
    [dades , ~, nom] = evalin('base',inst);
    
    
    %L'element seleccionat a la esquerre
    lot=get(handles.listbox1,'Value');%la posici del lot!
    inst=[ dade2 '.getBatch([' num2str(lot) ']);'];
    [dades2 , ~, nom2] = evalin('base',inst);
    
    
    %DATA hi tenim les variables en columnes
    m=floor(size(dades,2)/2);
    n=floor( (size(dades,2)+1)/2 );
    
    figure;
    
    tit = evalin('base',[dade1 '.getVariableLabel()']); 
    if isempty(tit)
        tit = 1:size(dades,2);
    end
    
    hold on;
    color_table=[winter(size(dades,3)); autumn(size(dades2,3))]; %tons blaus
    %color_table=[color_table ; rand(size(dades2,3),1)*0.5+0.5,rand(size(dades2,3),1)*0.5+0.5 ,rand(size(dades2,3),1)*0.5+0.5]; %tons verds
    
    if(m == 0)
        m=1;
    end
    for i = 1:size(dades,2) %per cada variable
        subplot(m,n,i)
        
        hold on
        ti = {};%nem preparant el legend
        for j= 1:size(dades,3)%per cada variable
            plot(1:size(dades,1),dades(:,i,j),'color',color_table(j,:))
            ti = {ti{:} ['Batch:' num2str(nom{j}) ' -- Object:' dade1]};
        end
        for j= 1:size(dades2,3)%per cada variable
            plot(1:size(dades2,1),dades2(:,i,j),'color',color_table(j+size(dades,3),:))
            ti = {ti{:} ['Batch:' num2str(nom2{j}) ' -- Object:' dade2]};
        end

        title(tit(i))
        
        legend(ti);
        legend('off');
        
        hold off
    end
    hold off;
end

function listbox2_Callback(~, ~, handles)
    %nom de l'objecte dades que s'esta mostran al list dreta
    dade=get(handles.popupmenu2,'String');
    dade=dade{get(handles.popupmenu2,'Value')};
    
    
    %L'element seleccionat a la dreta
    lot=get(handles.listbox2,'Value');%la posici del lot!
    if isempty(lot) || length(lot) ~=1
        set(handles.edit2,'String','');
    else
        inst=[ dade '.getBatch(' num2str(lot) ');'];
        [~, class ,~] = evalin('base',inst);
        set(handles.edit2,'String',num2str(class));
    end
    
function listbox1_Callback(~, ~, handles)
    %nom de l'objecte dades que s'esta mostran al list esquerre
    dade=get(handles.popupmenu1,'String');
    dade=dade{get(handles.popupmenu1,'Value')};
    
    
    %L'element seleccionat a la dreta
    lot=get(handles.listbox1,'Value');%la posici del lot!
    if isempty(lot) || length(lot) ~=1
        set(handles.edit1,'String','');
    else
        inst=[ dade '.getBatch(' num2str(lot) ');'];
        [~, class, ~] = evalin('base',inst);
        set(handles.edit1,'String',num2str(class));
    end
    
    
% -----Quan acciona el submenu seleccionem l'element de la llista-----
function contextm_Callback(~, ~, handles)
%fem un click dret per seleccionar l'element de la llista

if length(get(handles.listbox1,'Value')) <= 1
    R=java.awt.Robot;
    R.setAutoWaitForIdle(1);
    R.mousePress(java.awt.event.InputEvent.BUTTON1_MASK);
    R.mouseRelease(java.awt.event.InputEvent.BUTTON1_MASK);
end
function cuntextmd_Callback(~, ~, handles)
%fem un click dret per seleccionar l'element de la llista
if length(get(handles.listbox2,'Value')) <= 1
    R=java.awt.Robot;
    R.setAutoWaitForIdle(1);
    R.mousePress(java.awt.event.InputEvent.BUTTON1_MASK);
    R.mouseRelease(java.awt.event.InputEvent.BUTTON1_MASK);
end

% --------------------------------------------------------------------
%callbacks del menu del list dret
function EliminaDre_Callback(~, ~, handles)
%nom de l'objecte dades que s'esta mostran al list dret
dade=get(handles.popupmenu2,'String');
dade1=dade{get(handles.popupmenu2,'Value')};


%L'element sobre el qual s'ha cridat el menu indica el lot a eliminar!!
lot1=num2str(get(handles.listbox2,'Value'));%la posici del lot!

%comprobem que hi hagi lots seleccionats
if isempty(get(handles.listbox2,'String'))
    errordlg('Select one object!','Error');

else
    
    %construim la instruccio que l'eliminara
    inst=[  dade1 '.deleteBatch([' num2str(lot1) ']);'];
    evalin('base',inst);%la evaluo
    
    %actualitzem la llista dels lots
    aux=evalin('base',[dade1 '.getBatchLabel()']);
    set(handles.listbox2,'String', aux);
    set(handles.listbox2,'Value',length(aux));
    
    dad=get(handles.popupmenu1,'String');
    dad=dad{get(handles.popupmenu1,'Value')};
    if strcmp(dade,dad)
        set(handles.listbox1,'String', aux);
        set(handles.listbox1,'Value',length(aux));
    end
end

function MouDre_Callback(~, ~, handles)
% listbox1 <-- listbox2
%comprovem que hi hagi algun lot seleccionat
if isempty(get(handles.listbox2,'String'))
    errordlg('Select one object!','Error');

else
    
    %nom de l'objecte dades1
    dade=get(handles.popupmenu1,'String');
    dade1=dade{get(handles.popupmenu1,'Value')};
    
    
    %nom de l'objecte dades2
    dade=get(handles.popupmenu2,'String');
    dade2=dade{get(handles.popupmenu2,'Value')};
    
    
    if strcmp(dade1,dade2)
        errordlg('Selected objects are the same. Invalid action!','Error')

    else
        lot=get(handles.listbox2,'Value');%la posici del lot!
        inst=[ '[Temp_a1 Temp_a2 Temp_a3] =' dade2 '.getBatch([' num2str(lot) ']);'];
        evalin('base',inst);
        
        inst=[dade1 '.addBatch( Temp_a1, Temp_a2 ,Temp_a3 );'];
        evalin('base',inst);
        
        inst='clear Temp_a1 Temp_a2 Temp_a3 ';
        evalin('base',inst);
        
        inst=[  dade2 '.deleteBatch([' num2str(lot) ']);'];
        evalin('base',inst);
        
        %actualitzem la llista dels lots
        aux=evalin('base',[dade1 '.getBatchLabel()']);
        set(handles.listbox1,'String', aux);
        set(handles.listbox1,'Value',length(aux));
        
        aux=evalin('base',[dade2 '.getBatchLabel()']);
        set(handles.listbox2,'String', aux);
        set(handles.listbox2,'Value',length(aux));
    end
end

function CopyDre_Callback(~, ~, handles)
% listbox1 <-- listbox2
%comprovem que hi hagi algun lot seleccionat
if isempty(get(handles.listbox2,'String'))
    errordlg('Select one object!','Error');

else
    
    %nom de l'objecte dades1
    dade=get(handles.popupmenu1,'String');
    dade1=dade{get(handles.popupmenu1,'Value')};
    
    
    %nom de l'objecte dades2
    dade=get(handles.popupmenu2,'String');
    dade2=dade{get(handles.popupmenu2,'Value')};
    
    
    if strcmp(dade1,dade2)
        errordlg('Selected objects are the same. Invalid action!','Error')

    else
    lot=get(handles.listbox2,'Value');%la posici del lot!
    inst=[ '[Temp_a1 Temp_a2 Temp_a3] =' dade2 '.getBatch([' num2str(lot) ']);'];
    evalin('base',inst);
    
    inst=[dade1 '.addBatch( Temp_a1, Temp_a2 ,Temp_a3 );'];
    evalin('base',inst);
    
    inst='clear Temp_a1 Temp_a2 Temp_a3 ';
    evalin('base',inst);
    
    % %com l'anterior pero sense treure
    % inst=[  dade2 '.deleteBatch(' num2str(lot) ');'];
    % evalin('base',inst);
    
    %actualitzem la llista dels lots
    aux=evalin('base',[dade1 '.getBatchLabel()']);
    set(handles.listbox1,'String', aux);
    set(handles.listbox1,'Value',length(aux));
    
    %aux=evalin('base',[dade2 '.getBatchLabel()']);
    %set(handles.listbox2,'String', aux);
    %set(handles.listbox2,'Value',length(aux));
    end
end

function PlotVarsDre_Callback(~, ~, handles)
%comprovem que hi hagi algun lot seleccionat
if isempty(get(handles.listbox2,'String'))
    errordlg('Select one object!','Error');

else
    
    %nom de l'objecte dades que s'esta mostran al list dreta
    dade=get(handles.popupmenu2,'String');
    dade1=dade{get(handles.popupmenu2,'Value')};
    
    
    %L'element sobre el qual s'ha cridat el menu indica el lot a fer el plot
    lot=get(handles.listbox2,'Value');%la posici del lot!
    inst=[ dade1 '.getBatch([' num2str(lot) ']);'];
    [dades , ~, nom] = evalin('base',inst);
    
    %DATA hi tenim les variables en columnes
    m=floor(size(dades,2)/2);
    n=floor( (size(dades,2)+1)/2 );
    
    figure;
    
    tit = evalin('base',[dade1 '.getVariableLabel()']); 
    if isempty(tit)
        tit = 1:size(dades,2);
    end
    
    color_table = jet(size(dades,3));
    hold on;
    if(m == 0)
        m=1;
    end
    for i = 1:size(dades,2) %per cada variable
        subplot(m,n,i)
        if i == 1
            ti = {};%nem preparant el legend
            hold on;
            for j= 1:size(dades,3)%per cada variable
                plot(1:size(dades,1),dades(:,i,j),'color',color_table(j,:))
                ti = {ti{:} ['Batch:' num2str(nom{j}) ' -- Object:' dade1]};
            end
            hold off;
        else
            %nomes cal calcular la llegenda 1 cop!
            hold on;
            for j= 1:size(dades,3)%per cada variable
                plot(1:size(dades,1),dades(:,i,j),'color',color_table(j,:))
            end
            hold off;
        end
        %plot(1:size(dades,1),dades(:,i))
        title(tit(i))
        %legend({strcat('Lot:',num2str(nom{1}),' -- Objecte:', dade1)})
        legend(ti)
        legend('off')
    end
    hold off;
end

function CanviaClasseDre_Callback(~, ~, handles)
if isempty(get(handles.listbox2,'String'))
    errordlg('Select one object!','Error');

else
    %nom de l'objecte dades2
    dade=get(handles.popupmenu2,'String');
    dade2=dade{get(handles.popupmenu2,'Value')};
    
    
    class = evalin('base',[dade2 '.getClass()']);
    index = get(handles.listbox2,'Value');%la posici del lot a canviar
    
     answer = inputdlg('Wich class should have?');
     answer = str2double(answer);
     
     while isnan(answer)
         errordlg('Classes must be Integer!','Error')
         
         uiwait(gcf);
         answer = inputdlg('Wich class should have?');
         answer = str2double(answer);
     end
    
     if ~isempty(answer)
         class(index) = answer;
         evalin('base',[dade2 '.setClass([' num2str(class) ']);']);
         set(handles.edit2,'String',num2str(answer));
         if (get(handles.popupmenu2,'Value')== get(handles.popupmenu1,'Value')) && (get(handles.listbox2,'Value') == get(handles.listbox1,'Value'))
            set(handles.edit1,'String',num2str(answer));
         end
     end
end

function CanviaNomDre_Callback(~, ~, handles)
if isempty(get(handles.listbox2,'String'))
    errordlg('select one object!','Error');

else
    %nom de l'objecte dades2
    dade=get(handles.popupmenu2,'String');
    dade2=dade{get(handles.popupmenu2,'Value')};
    
    
    class = evalin('base',[dade2 '.getBatchLabel()']);
    index = get(handles.listbox2,'Value');%la posici del lot a canviar
    
     answer = inputdlg('Which name should have?');
    
     if ~isempty(answer)
         class(index) = answer;
         aux =  evalin('base',[dade2 '.copy();']);
         aux.setBatchLabel(class);
         
         
         assignin('base',dade2, aux);

         set(handles.listbox2,'String', class)
         
         if (get(handles.popupmenu2,'Value')== get(handles.popupmenu1,'Value'))
            set(handles.listbox1,'String', class)
         end
     end
end


% --------------------------------------------------------------------
%callbacks del menu del list esquerre
function EliminaEsq_Callback(~, ~, handles)
%nom de l'objecte dades que s'esta mostran al list esquerre
dade=get(handles.popupmenu1,'String');
dade1=dade{get(handles.popupmenu1,'Value')};


%L'element sobre el qual s'ha cridat el menu indica el lot a eliminar!!
lot1=num2str(get(handles.listbox1,'Value'));%la posici del lot!

%comprobem que hi hagi lots seleccionats
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');

else
    
    %construim la instruccio que l'eliminara
    inst=[  dade1 '.deleteBatch([' num2str(lot1) ']);'];
    evalin('base',inst);%la evaluo
    
    %actualitzem la llista dels lots
    aux=evalin('base',[dade1 '.getBatchLabel()']);
    set(handles.listbox1,'String', aux);
    set(handles.listbox1,'Value',length(aux));
    
    dad=get(handles.popupmenu2,'String');
    dad=dad{get(handles.popupmenu2,'Value')};
    if strcmp(dade1,dad)
        set(handles.listbox2,'String', aux);
        set(handles.listbox2,'Value',length(aux));
    end
end

function MouEsq_Callback(~, ~, handles)
% listbox1 --> listbox2

%comprobem que hi hagi lots seleccionats
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');
else
    
    %nom de l'objecte dades1
    dade=get(handles.popupmenu1,'String');
    dade1=dade{get(handles.popupmenu1,'Value')};
    
    
    %nom de l'objecte dades2
    dade=get(handles.popupmenu2,'String');
    dade2=dade{get(handles.popupmenu2,'Value')};
    
    
    if strcmp(dade1,dade2)
        errordlg('Selected objects are the same. Invalid action!','Error')

    else
        lot=get(handles.listbox1,'Value');%la posici del lot!
        inst=[ '[Temp_a1 Temp_a2 Temp_a3] =' dade1 '.getBatch([' num2str(lot) ']);'];
        evalin('base',inst);
        
        inst=[dade2 '.addBatch( Temp_a1, Temp_a2 ,Temp_a3 );'];
        evalin('base',inst);
        
        inst='clear Temp_a1 Temp_a2 Temp_a3 ';
        evalin('base',inst);
        
        inst=[  dade1 '.deleteBatch([' num2str(lot) ']);'];
        evalin('base',inst);
        
        %actualitzem la llista dels lots
        aux=evalin('base',[dade1 '.getBatchLabel()']);
        set(handles.listbox1,'String', aux);
        set(handles.listbox1,'Value',length(aux));
        
        aux=evalin('base',[dade2 '.getBatchLabel()']);
        set(handles.listbox2,'String', aux);
        set(handles.listbox2,'Value',length(aux));
    end
end

function CopyEsq_Callback(~, ~, handles)
% listbox1 --> listbox2

%comprobem que hi hagi lots seleccionats
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');

else
    
    %nom de l'objecte dades1
    dade=get(handles.popupmenu1,'String');
    dade1=dade{get(handles.popupmenu1,'Value')};
    
    
    %nom de l'objecte dades2
    dade=get(handles.popupmenu2,'String');
    dade2=dade{get(handles.popupmenu2,'Value')};
    
    
    if strcmp(dade1,dade2)
        errordlg('Selected objects are the same. Invalid action!','Error')

    else
        lot=get(handles.listbox1,'Value');%la posici del lot!
        inst=[ '[Temp_a1 Temp_a2 Temp_a3] =' dade1 '.getBatch([' num2str(lot) ']);'];
        evalin('base',inst);
        
        inst=[dade2 '.addBatch( Temp_a1, Temp_a2 ,Temp_a3 );'];
        evalin('base',inst);
        
        inst='clear Temp_a1 Temp_a2 Temp_a3 ';
        evalin('base',inst);
        
        %actualitzem la llista dels lots
        %    aux=evalin('base',[dade1 '.getBatchLabel()']);
        %    set(handles.listbox1,'String', aux);
        %    set(handles.listbox1,'Value',length(aux));
        
        aux=evalin('base',[dade2 '.getBatchLabel()']);
        set(handles.listbox2,'String', aux);
        set(handles.listbox2,'Value',length(aux));
    end
end

function PlotVarsEsq_Callback(~, ~, handles)
%comprobem que hi hagi lots seleccionats
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');

else
    
    %nom de l'objecte dades que s'esta mostran al list esquerre
    dade=get(handles.popupmenu1,'String');
    dade1=dade{get(handles.popupmenu1,'Value')};
    
    
    %L'element sobre el qual s'ha cridat el menu indica el lot a fer el plot
    lot=get(handles.listbox1,'Value');%la posici del lot!
    inst=[ dade1 '.getBatch([' num2str(lot) ']);'];
    [dades , ~, nom] = evalin('base',inst);
    
    %DATA hi tenim les variables en columnes
    m=floor(size(dades,2)/2);
    n=floor( (size(dades,2)+1)/2 );
    
    figure;
    
    %agafem els noms de les variables
    tit = evalin('base',[dade1 '.getVariableLabel()']); 
    if isempty(tit)
        tit = 1:size(dades,2);
    end
    color_table = jet(size(dades,3));
    hold on;
    if(m == 0)
        m=1;
    end
    for i = 1:size(dades,2) %per cada variable
        subplot(m,n,i)
        
        if i == 1
            ti = {};%nem preparant el legend
            hold on;
            for j= 1:size(dades,3)%per cada variable
                plot(1:size(dades,1),dades(:,i,j),'color',color_table(j,:))
                ti = {ti{:} ['Batch:' num2str(nom{j}) ' -- Object:' dade1]};
            end
            hold off;
        else
            %nomes cal calcular la llegenda 1 cop!
            hold on;
            for j= 1:size(dades,3)%per cada variable
                plot(1:size(dades,1),dades(:,i,j),'color',color_table(j,:))
            end
            hold off;
        end
        
        %plot(1:size(dades,1),dades(:,i))
        title(tit(i))
        
        legend(ti)
        legend('off')
    end
    hold off;
end

function CanviaClasseEsq_Callback(~, ~, handles)
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');

else
    %nom de l'objecte dades1 (el de l'esquerre)
    dade=get(handles.popupmenu1,'String');
    dade2=dade{get(handles.popupmenu1,'Value')};
    
    
    class = evalin('base',[dade2 '.getClass()']);
    index = get(handles.listbox1,'Value');%la posici del lot a canviar
    
     answer = inputdlg('Which class should have?');
     answer = str2double(answer);
     
     while isnan(answer)
         errordlg('Classes must be Integers!','Error')

         uiwait(gcf);
        answer = inputdlg('Wich class should have?');
        answer = str2double(answer);
     end
    
     if ~isempty(answer)
         class(index) = answer;
         evalin('base',[dade2 '.setClass([' num2str(class) ']);']);
         set(handles.edit1,'String',num2str(answer));
         if (get(handles.popupmenu2,'Value')== get(handles.popupmenu1,'Value')) && (get(handles.listbox2,'Value') == get(handles.listbox1,'Value'))
            set(handles.edit2,'String',num2str(answer));
         end
     end
end


function CanviaNomEsq_Callback(~, ~, handles)
if isempty(get(handles.listbox1,'String'))
    errordlg('Select one object!','Error');
else
    %nom de l'objecte dades2
    dade=get(handles.popupmenu1,'String');
    dade2=dade{get(handles.popupmenu1,'Value')};
    
    
    class = evalin('base',[dade2 '.getBatchLabel()']);
    index = get(handles.listbox1,'Value');%la posici del lot a canviar
    
     answer = inputdlg('which name should have?');
    
     if ~isempty(answer)
         class(index) = answer;
         aux =  evalin('base',[dade2 '.copy();']);
         aux.setBatchLabel(class);
         
         assignin('base',dade2, aux);

         set(handles.listbox1,'String', class)
         
         if (get(handles.popupmenu2,'Value')== get(handles.popupmenu1,'Value'))
            set(handles.listbox2,'String', class)
         end
     end
end


%% -- INUTILS --
function popupmenu1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function listbox1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function listbox2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function varargout = Menu_Canvia_Lots_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
function edit2_Callback(~, ~, ~)
function edit2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit1_Callback(~, ~, ~)
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function Untitled_1_Callback(~, ~, ~)
