function varargout = Menu_Crea_Model_PCA(varargin)
%Pantalla per crear models PCA a partir de objectes tipus DATA presents al
%workspace. Els nous objectes PCA seran creats al orkspace amb el nom que
%indiqui l'usuari
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Crea_Model_PCA();
%
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Crea_Model_PCA_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Crea_Model_PCA_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% --- Executes just before Menu_Crea_Model_PCA is made visible.
function Menu_Crea_Model_PCA_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

handles.output = hObject;
guidata(hObject, handles);

x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
       list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end
set(handles.llistadades,'String',list);


% --- Outputs from this function are returned to the command line.
function varargout = Menu_Crea_Model_PCA_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;


% --- Executes on selection change in llistadades.
function llistadades_Callback(~, ~, ~)

% --- Executes during object creation, after setting all properties.
function llistadades_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in LoadDades.
function LoadDades_Callback(~, ~, ~)
uiwait(Menu_Load_Dades());


function edit1_Callback(~, ~, ~)

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Genera.
function Genera_Callback(~, ~, handles)
try
variable=get(handles.llistadades,'String');
variable=variable{get(handles.llistadades,'Value')};


nom=get(handles.edit1,'String');


if ~isempty(evalin('base',['whos([''' nom '''])'] ))
    choice = questdlg('Selected Name is in use, do you want to oberwrite?', 'Attention', 'Yes','No','No');
    switch choice
        case 'Yes'
            %Sobreescriure

            evalin('base',[nom '=PCA(' variable ');']);
            
            close('Menu_Crea_Model_PCA');
            Update_Caller();
            
        case 'No'
            %No fer res
    end
else

    evalin('base',[nom '=PCA(' variable ');']);
    
    close('Menu_Crea_Model_PCA');
    Update_Caller();
end

catch err
    errordlg(err.message,'Error');
end

function Update(hObject, ~, handles) 
handles.output = hObject;

%Tornem a crear la llista d'objectes DATA
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
        list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA Object in workspace'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.llistadades,'String');
nom=nom{get(handles.llistadades,'Value')};


%busquem aquest nom entre la llista actual

val=find(strcmp(nom,list));
set(handles.llistadades,'String',list);

if isempty(val)
    set(handles.llistadades,'Value',1);
    
    %i desactivem els menus!

else
    set(handles.llistadades,'Value',val);
end
guidata(hObject, handles);
