function varargout = Menu_Crear_Dades(varargin)
%Pantalla Per crear objectes DATa nous a partir de dades disponibles al
%workspace.
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Crear_Dades();
%

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Crear_Dades_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Crear_Dades_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_Crear_Dades_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.


handles.output = hObject;
guidata(hObject, handles);
event = struct('EventName','SelectionCanged','OldValue',handles.radiobutton2,'NewValue',handles.radiobutton1);
uipanel1_SelectionChangeFcn(hObject, event, handles)

function listbox1_Callback(~, ~, handles)
nom=get(handles.listbox1,'String');
if ~isempty(nom)%la llista esta buida! <- no hauria d'apareixer mai
    nom=nom{get(handles.listbox1,'Value')};
    if ~strcmp(nom,'No data')%hi ha misatge de que no hi ha dades!
        inst=['whos(''' nom ''');'];
        x=evalin('base',inst);
        set(handles.text7,'String',x.class);
        set(handles.text8,'String',[ '[' num2str(x.size) ']' ]);
        
        if get(handles.uipanel1,'SelectedObject') == handles.radiobutton1
            %si s 2D hem de comprobar el format que em passen les dades
            %per poder saver una de les 3 dimmencions
            
            if get(handles.uipanel3,'SelectedObject') == handles.radiobutton4
                %Les dades estan en VW
                set(handles.edit1,'String','');
                set(handles.edit2,'String','');
                set(handles.edit3,'String',num2str(x.size(2)));
            else
                %les dades estan en BW
                set(handles.edit1,'String','');
                set(handles.edit2,'String',num2str(x.size(1)));
                set(handles.edit3,'String','');
            end
        else
            %es 3D ja savem les dimencions
            set(handles.edit1,'String',num2str(x.size(1)));
            set(handles.edit2,'String',num2str(x.size(3)));
            set(handles.edit3,'String',num2str(x.size(2)));
            
            set(handles.pushbutton2,'Enable','on');
        end
        
    else
        set(handles.text7,'String','No selected object!');
        set(handles.text8,'String','No selected object!');
    end
else
    set(handles.text7,'String','No selected object!');
    set(handles.text8,'String','No selected object!');
end

function pushbutton1_Callback(~, ~, handles)
nomobj=get(handles.listbox1,'String');
nomobj=nomobj{get(handles.listbox1,'Value')};

%nom del CBR que crearem
nom=get(handles.edit4,'String');


if ~isempty(evalin('base',['whos([''' nom '''])'] ))
    choice = questdlg('Selected name is used, do you want to overwrite?', 'Attention', 'Yes','No','No');
    switch choice
        case 'Yes'
            %Sobreescriure
            %creem la variable com a global
            %inst=['global ' nom];evalin('base',inst);
            inst=[nom '=DATA();'];evalin('base',inst);
            
            temps = get(handles.edit1,'String');
            lots = get(handles.edit2,'String');
            vars = get(handles.edit3,'String');
            if get(handles.uipanel1,'SelectedObject') == handles.radiobutton1
                %s 2D
                
                if get(handles.uipanel3,'SelectedObject') == handles.radiobutton4
                    %Les dades estan en VW
                    inst = [nom '.setRawDataVW(double(' nomobj '),' vars ',' temps ',' lots ');'];
                    evalin('base',inst);
                else
                    %les dades estan en BW
                    inst = [nom '.setRawDataBW(double(' nomobj '),' vars ',' temps ',' lots ');'];
                    evalin('base',inst);
                end
            else
                %es 3D ja savem les dimencions
                inst = [nom '.setRawData(double(' nomobj '));'];
                evalin('base',inst);
            end
            
            
            close('Menu_Crear_Dades');
            %actualitzem les llistes d'objectes de totes les finestres
            Update_Caller();
            uiwait(warndlg('Object class field is empty!','Attention!'));
            Menu_Editar_Dades2;
            
        case 'No'
            %No fer res
    end
else
    %creem la variable com a global
    %inst=['global ' nom];evalin('base',inst);
    inst=[nom '=DATA();'];evalin('base',inst);
    
    
    temps = get(handles.edit1,'String');
    lots = get(handles.edit2,'String');
    vars = get(handles.edit3,'String');
    if get(handles.uipanel1,'SelectedObject') == handles.radiobutton1
        %s 2D
        
        if get(handles.uipanel3,'SelectedObject') == handles.radiobutton4
            %Les dades estan en VW
            inst = [nom '.setRawDataVW(double(' nomobj '),' vars ',' temps ',' lots ');'];
            evalin('base',inst);
        else
            %les dades estan en BW
            inst = [nom '.setRawDataBW(double(' nomobj '),' vars ',' temps ',' lots ');'];
            evalin('base',inst);
        end
    else
        %es 3D ja savem les dimencions
        inst = [nom '.setRawData(double(' nomobj '));'];
        evalin('base',inst);
    end
    
    close('Menu_Crear_Dades');
    %actualitzem les llistes d'objectes de totes les finestres
    Update_Caller();
    uiwait(warndlg('Object class field is empty!','Attention!'));
    Menu_Editar_Dades2;
end

function uipanel3_SelectionChangeFcn(hObject, eventdata, handles)
listbox1_Callback(hObject, eventdata, handles);

function uipanel1_SelectionChangeFcn(~, eventdata, handles)
switch get(eventdata.NewValue,'Tag') % mirem qui han seleccionat
    case 'radiobutton1'
        %Matriu 2D
        
        %fem que nomes es vegin les matrius 2D a la llista
        
        x=evalin('base','whos();');
        list=[];
        for i=1:length(x)
            if x(i).size(1) > 1 && evalin('base',['isnumeric(' x(i).name() ');']) && x(i).size(2) > 1 && length(x(i).size) == 2
               list=[list; {x(i).name()}];
            end
        end
        if isempty(list)
            list={'No data'};
            set(handles.uipanel4,'visible','off')
        else
            set(handles.uipanel4,'visible','on')
        end
        set(handles.listbox1,'String',list);
        
        %fem visible el selector BW VW
        set(handles.uipanel3,'visible','on');
        set(handles.edit1,'Enable','on');
        set(handles.edit2,'Enable','on');
        set(handles.edit3,'Enable','on');
        
        set(handles.pushbutton2,'visible','off');
        set(handles.pushbutton2,'Enable','off');
        
        set(handles.text12,'visible','on');
        set(handles.text13,'visible','on');
        set(handles.text14,'visible','on');
        
    case 'radiobutton2'
        %Matriu 3D
        
        %fem que nomes es vegin les matrius 3D a la llista
        
        x=evalin('base','whos();');
        list=[];
        for i=1:length(x)
            if length(x(i).size) == 3 && evalin('base',['isnumeric(' x(i).name() ');']) && x(i).size(1) > 1 &&   x(i).size(2) > 1 &&   x(i).size(3) > 1
               list=[list; {x(i).name()}];
            end
        end
        if isempty(list)
            list={'No data'};
            set(handles.uipanel4,'visible','off')
        else
            set(handles.uipanel4,'visible','on')
        end
        set(handles.listbox1,'String',list);
        
        %fem visible el selector BW VW
        set(handles.uipanel3,'visible','off');
        set(handles.edit1,'Enable','off');
        set(handles.edit2,'Enable','off');
        set(handles.edit3,'Enable','off');
        
        set(handles.text12,'visible','off');
        set(handles.text13,'visible','off');
        set(handles.text14,'visible','off');
        
        set(handles.pushbutton2,'visible','on');
        set(handles.pushbutton2,'Enable','off');
        
    otherwise
        %Per si passen coses rares!
end
set(handles.listbox1,'value',1);
set(handles.text7,'String','No selected object!');
set(handles.text8,'String','No selected object!');
set(handles.edit1,'String','');
set(handles.edit2,'String','');
set(handles.edit3,'String','');

function pushbutton2_Callback(hObject, eventdata, handles)
%demanem a l'usuari com bol permutar les dimencions!
answer = inputdlg('Whe need a permutation vector [ dim1 dim2 dim3 ]:', 'Permutation vector');
if ~isempty(answer)
    nom=get(handles.listbox1,'String');
    nom=nom{get(handles.listbox1,'Value')};
     if ~strcmp(nom,'No data')%hi ha misatge de que no hi ha dades!
        ins =  [nom ' = permute(' nom ',' answer{:} ');'];
        evalin('base',ins);
         listbox1_Callback(hObject, eventdata, handles);%fem que actualitzi els valors!
     end
end


%% ------------------- inutils -----------------------
function listbox1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit4_Callback(~, ~, ~)
function edit4_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit1_Callback(~, ~, ~)
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit2_Callback(~, ~, ~)
function edit2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit3_Callback(~, ~, ~)
function edit3_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function varargout = Menu_Crear_Dades_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;
