function varargout = Menu_Cross(varargin)
%Pantalla per facilitar l'us de la Funci Cross4, Aquesta pantalla ens
%permetr escollir la configuraci amb que bolem realitzar el cross
%validation. Un cop configurat s'ens mostraran els resultats mitjanant
%plots i altres pantalles.
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Cross();
%

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Cross_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Cross_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% --- Executes just before Menu_Cross is made visible.
function Menu_Cross_OpeningFcn(hObject, ~, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

%Menu
handles.output = hObject;
handles=menu(handles);
guidata(hObject, handles);

%busquem tots els objectes dades que hi hagi
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
       list=[list; {x(i).name}];
    end
end
%si no ni ha escrivim un misatge
if isempty(list)
    list={'No hi ha cap objecte DATA'};
end
%posem la llista de variables disponibles al popup menu
set(handles.popupmenu1,'String',list);

set(handles.popupmenu2,'Enable','off');
set(handles.popupmenu3,'Enable','off');
set(handles.popupmenu4,'Enable','off');

set(handles.edit1,'Enable','off');
set(handles.edit2,'Enable','off');


set(handles.pushbutton1,'Enable','off');

set(handles.popupmenu8,'Enable','off');
set(handles.popupmenu9,'Enable','off');
set(handles.popupmenu10,'Enable','off');
set(handles.popupmenu11,'Enable','off');
set(handles.popupmenu12,'Enable','off');
set(handles.popupmenu13,'Enable','off');
popupmenu1_Callback(-1, -1, handles);
popupmenu2_Callback(-1, -1, handles);

% --- Outputs from this function are returned to the command line.
function varargout = Menu_Cross_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;

% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(~, ~, handles)
set(handles.popupmenu2,'Enable','on');
set(handles.popupmenu3,'Enable','on');
set(handles.popupmenu4,'Enable','on');

set(handles.edit1,'Enable','on');
set(handles.edit2,'Enable','on');
%set(handles.edit3,'Enable','on');

set(handles.pushbutton1,'Enable','on');

set(handles.popupmenu8,'Enable','on');
set(handles.popupmenu9,'Enable','on');
set(handles.popupmenu10,'Enable','on');
set(handles.popupmenu11,'Enable','on');
set(handles.popupmenu12,'Enable','on');
set(handles.popupmenu13,'Enable','on');

% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(~, ~, handles)
%recupero el nom de 'lobjecte que ha seleccionat l'usuari
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};

a=evalin('base',[ nom '.copy;']);

dc=get(handles.popupmenu2,'Value');

metode=get(handles.popupmenu3,'Value');

net=get(handles.popupmenu4,'Value');

div=str2double(get(handles.edit1,'String'));

parami=-1;
switch dc
    case 4
        %distancies dobles
        vk=[ str2double(get(handles.edit2,'String')) str2double(get(handles.edit6,'String')) ];
    case 5
        %distancies dobles
        vk=[ str2double(get(handles.edit2,'String')) str2double(get(handles.edit6,'String')) ];
    case 6
        %distancies dobles
        vk=[ str2double(get(handles.edit2,'String')) str2double(get(handles.edit6,'String')) ];
        
    case 17
        %distancia simple mes parametre extra
        vk=[ str2double(get(handles.edit2,'String'))  str2double(get(handles.edit2,'String')) ];
        parami =str2double( get(handles.edit6,'String'));
        
    case 18
        %distancia simple mes parametre extra
        vk=[ str2double(get(handles.edit2,'String'))  str2double(get(handles.edit2,'String')) ];
        parami =str2double( get(handles.edit6,'String'));
        
    otherwise
        %distancies simples nomes necesitem un numero
        vk=[ str2double(get(handles.edit2,'String')) str2double(get(handles.edit2,'String')) ];
end

%Recuperem les classes

%classes = str2double(get(handles.edit7,'String')); %ha deixat de
%funcionar!!!
classes = eval(get(handles.edit7,'String'));

%BW o VW
W= get(handles.popupmenu11,'Value')-1;
%fixem el metode d'estandaritzacio
est= get(handles.popupmenu8,'Value');
%treure forma mitja
FM = get(handles.popupmenu10,'Value')-1;
%fixem el metode de seleccio de components principals
Metode = get(handles.popupmenu9,'Value')-1;
%calcullimits
limits= get(handles.popupmenu12,'Value')-1;

conts= get(handles.popupmenu13,'Value')-1;

if isempty(a.getBatchLabel())
    a.setBatchLabel(num2cell(1:a.getBatchCount))
end

% [a b ~]=Cross3(a,div,vk ,dc,metode,net,W,est,FM,Metode,limits,conts,classes,parami,'plots');

[a b]=Cross4(a,div,vk ,dc,metode,net,W,est,FM,Metode,limits,conts,classes,parami,'plots');
 Menu_Veure_Veins_2(a,b);


function pushbutton2_Callback(~, ~, ~)
uiwait(Menu_Load_Dades());


function popupmenu1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit1_Callback(~, ~, ~)
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit2_Callback(~, ~, ~)
function edit2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% function edit3_Callback(~, ~, ~)
% function edit3_CreateFcn(hObject, ~, ~)
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end
function popupmenu2_Callback(~, ~, handles)
switch get(handles.popupmenu2,'value')
    case 4
        set(handles.text4,'string','Number of cases to retrieve (Q)')
        set(handles.text18,'string','Number of cases to retrieve (T^2)')
        set(handles.text18,'visible','on');
        set(handles.edit6,'visible','on');
        
    case 5
        set(handles.text4,'string','Number of cases to retrieve (Q)')
        set(handles.text18,'string','Number of cases to retrieve (PC)')
        set(handles.text18,'visible','on');
        set(handles.edit6,'visible','on');
        
    case 6
        set(handles.text4,'string','Number of cases to retrieve (T^2)')
        set(handles.text18,'string','Number of cases to retrieve (PC)')
        set(handles.text18,'visible','on');
        set(handles.edit6,'visible','on');
        
    case 17
        set(handles.text4,'string','Number of cases to retrieve')
        set(handles.text18,'string','distance parameter')
        set(handles.text18,'visible','on');
        set(handles.edit6,'visible','on');
        
    case 18
        set(handles.text4,'string','Number of cases to retrieve')
        set(handles.text18,'string','distance parameter')
        set(handles.text18,'visible','on');
        set(handles.edit6,'visible','on');
        
    otherwise
        %distancies d'1 nivell i sense parametres extres
        set(handles.text4,'string','Number of cases to retrieve')
        set(handles.text18,'visible','off');
        set(handles.edit6,'visible','off');
    
end

function popupmenu2_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu3_Callback(~, ~, ~)
function popupmenu3_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu4_Callback(~, ~, ~)
function popupmenu4_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu8_Callback(~, ~, ~)
function popupmenu8_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu9_Callback(~, ~, ~)
function popupmenu9_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu10_Callback(~, ~, ~)
function popupmenu10_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu11_Callback(~, ~, ~)
function popupmenu11_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function popupmenu12_Callback(~, ~, ~)
function popupmenu12_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function Update(hObject, ~, handles) 
handles.output = hObject;
handles=menu(handles);

%Tornem a crear la llista d'objectes DATA
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
        list=[list; {x(i).name}];
    end
end
if isempty(list)
    list={'No DATA object in workspace'};
end

%busquem el valor que te el popupmenu actualment
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};


%busquem aquest nom entre la llista actual

val=find(strcmp(nom,list));
set(handles.popupmenu1,'String',list);

if isempty(val)
    set(handles.popupmenu1,'Value',1);
    
    %i desactivem els menus!
    set(handles.popupmenu2,'Enable','off');
    set(handles.popupmenu3,'Enable','off');
    set(handles.popupmenu4,'Enable','off');
    
    set(handles.edit1,'Enable','off');
    set(handles.edit2,'Enable','off');
    %set(handles.edit3,'Enable','off');
    
    set(handles.pushbutton1,'Enable','off');
    
    set(handles.popupmenu8,'Enable','off');
    set(handles.popupmenu9,'Enable','off');
    set(handles.popupmenu10,'Enable','off');
    set(handles.popupmenu11,'Enable','off');
    set(handles.popupmenu12,'Enable','off');
    set(handles.popupmenu13,'Enable','off');
    
else
    set(handles.popupmenu1,'Value',val);
end

guidata(hObject, handles);
function popupmenu13_Callback(~, ~, ~)
function popupmenu13_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit6_Callback(~, ~, ~)
function edit6_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit7_Callback(~, ~, ~)
function edit7_CreateFcn(hObject, ~, ~)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
