function varargout = Menu_Load_Dades(varargin)
%Pantalla per carregar objectes DATA des de fitxer al workspace. Permetem
%diversos formats de fitxer (CSV, Mat)
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Load_Dades();
%

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Load_Dades_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Load_Dades_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_Load_Dades_OpeningFcn(hObject, ~, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);

% --- S'executa en pulsar OK 
function OK_Callback(~, ~, handles)
nom=get(handles.nom,'String');
if isempty(nom)
    errordlg('A variable needs a name','Error');
elseif str2double(nom(1))<10
    errordlg('A variable never starts with a number','Error');
else
    nom = genvarname(nom);%passem el que hagi entrat l'usuari a nom valid de variable
    try
        if ~isempty(evalin('base',['whos( ''' nom ''' )'] ))
            choice = questdlg('this name is used, do you want to overwrite?', 'Attention', 'Yes','No','No');
            switch choice
                case 'Yes'
                    %Sobreescriure
                    evalin('base',[ nom '=DATA();']);
                    format=get(handles.Format,'String');
                    format=format{get(handles.Format,'Value')};
                    fitxer=get(handles.Ruta,'String');
                    evalin('base',[ nom '.load(''' fitxer ''', ''' format ''');']);
                    
                    close('Menu_Load_Dades');
                    Update_Caller();
                    
                case 'No'
                    %No fer res
                    
            end
        else
            
            evalin('base',[ nom '=DATA();']);
            format=get(handles.Format,'String');
            format=format{get(handles.Format,'Value')};
            fitxer=get(handles.Ruta,'String');
            evalin('base',[ nom '.load(''' fitxer ''', ''' format ''');']);
            
            close('Menu_Load_Dades');
            Update_Caller();
        end
    catch err
        errordlg(err.message,'Error');
    end
end

% --- S'executa en pulsar Selecciona
function Selecciona_Callback(~, ~, handles)
[FileName,PathName,~] = uigetfile('*.*');

if FileName ==0 
 set(handles.Ruta,'String','No file selected');
else
 set(handles.Ruta,'String',strcat(PathName,FileName));
end

%-----------------------------INUTILS--------------------------------------
function varargout = Menu_Load_Dades_OutputFcn(~, ~, handles)
varargout{1} = handles.output;
function Format_Callback(~, ~, ~)
function Format_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function nom_Callback(~, ~, ~)
function nom_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
