function Update_Caller()
%Aquesta funcio invocara el metode Update de totes les finestres que hi
%hagi obertes en aquest moment. A cada finestra s'ha de definir com
%actualitzar-la, si no sera ignorada i no s'actualitzara.
%
%Aquesta Funci no te parametres d'entrada ni de sortida.
%
%Exemple de funci Update basica per actualitzar el menu
%
% function Update(hObject, eventdata, handles) 
%   %Aquesta funci actualitza la finestra
%   handles.output = hObject; %posem com  output el hObject
%   handles=menu(handles); %crido el menu -> s'auto actualitza!
%   guidata(hObject, handles); %actualitzem lapart visual
% end

figHandles = findall(0,'Type','figure');%busquem totes les figures que tenim obertes
for i=1:length(figHandles) %per cada una d'elles
    try
        %recuperem el nom del fitxer amb el handle
        [~, name, ~] = fileparts(handle(figHandles(i)).FileName) ;
        
        if ~isempty(name)
            eval([name '(''Update'',handle(figHandles(i)),[],guidata(handle(figHandles(i))))' ]); %Li invoquem el metode Update(hObject, eventdata, handles) --> Cal definir-lo manualment
        end
        
    catch 
        %nomes es donara error quan existeixi alguna UI oberta que no hagi
        %definit la funci update, pot no formar part de les nostres UI per
        %tant no mostrarem error.
    end
end

