function dist=dpr( px,py , r1x,r1y , r2x,r2y)
%Funci per calcula la distanci entre 2 punts i una recta indicada amb 2
%punts.
%
%Parametres d'entrada:
%
%   (px,py) - coordenades del punt del punt (doubles)
%
%   (r1x,r1y) i (r2x,r2y) - dos punts diferents de la recta (doubles)
%
%Parametres de sortida:
%
%   dist - Double que indica la distancia entre la recta i el punt
%

%construim la recta que passa pels 2 puns que ens han donat
A = r2y - r1y;
B = -(r2x - r1x);
C = -(r1x*(r2y - r1y))+(r1y*(r2x-r1x)) ;
%recta Ax +By +C =0

%calculem la distancia
dist=abs(A*px+B*py+C)/sqrt(A^2+B^2);
%                   |A *px + B*py + C|
%dist (Punt recta)=--------------------
%                     sqrt(A^2+B^2)
end