function plot_Bars(f)
%Fem el grafic de barres amb le precissio de cada una de les particions
%
%Parametres d'entrada
%
%   f - Son els casos que fallen a cada una de les particions 1= falla 0=
%       no falla.
%       S'ha de entrar un cell i dins d'aquest un list per cada una de les
%       particions amb 1 o o segons si el cas falla o no.
%
%       Exemple:
%       part1 = [1 0 1];
%       part2 = [1 1 1];
%       part3 = [1 0 0];
%       {part1 part2 part3}
%
%Parametres de sortida 
%
%   No en t, fa el plot corresponent i prou
%

%comenem obrint una nova finestra
figure();

%posem el titol i el nom dels eixos
hold on;
title('% of prediction succes','FontSize',20);
ylabel('%');
xlabel('Division');

%fem els calculs del % d'encerts (altura de la barra) i les dibuixem en
%blau
for i=1:length(f)
    bar(i,sum(f{i}==0)/length(f{i})*100,'b')
end

%fem els calculs globals i dibuixem la barra en vermell
bar(i+2,sum([f{:}]==0)/length([f{:}])*100,'r');

%Posem els numeros de les particions
set(gca,'xtick',1:i);
text(i+1.75,-3.5,'average');
hold off
end