function varargout = Menu_Editar_Dades2(varargin)
%Pantalla per mostrar/editar els atributs dels objectes DATA, tamb es
%permetra carregar-hi dades directament des del workspace.
%
%Per invocar directament des de consola aquesta pantalla nomes cal
%invocar-ne la funcio sense cap parametre extra:
%Menu_Editar_Dades2();
%
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Menu_Editar_Dades2_OpeningFcn, ...
                   'gui_OutputFcn',  @Menu_Editar_Dades2_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Menu_Editar_Dades2_OpeningFcn(hObject, eventdata, handles, varargin)
%funci que s'invoca en crear la finestra a varargin ens arriven el
%possibles parametres extres d'invocaci de Pantalla. No els
%utilitzarem per res. hObject i handles els modificarem.

handles.output = hObject;
guidata(hObject, handles);

%busquem tots els objectes dades que hi hagi
x=evalin('base','whos();');
list=[];
for i=1:length(x)
    if strcmp(x(i).class,'DATA') ~=0
       list=[list; {x(i).name}];
    end
end
%si no ni ha escrivim un misatge
if isempty(list)
    list={'No DATA object in Workspace'};
end
%posem la llista de variables disponibles al popup menu
set(handles.popupmenu1,'String',list);

%Amaguem tots els camps que no tenen valor de moment
set(handles.uitable1,'Visible','off');
set(handles.uitable2,'Visible','off');
set(handles.uitable3,'Visible','off');
%i el boto de guardar
set(handles.pushbutton1,'Visible','off');
set(handles.pushbutton2,'Visible','off');
set(handles.pushbutton3,'Visible','off');
set(handles.pushbutton4,'Visible','off');
set(handles.pushbutton5,'Visible','off');

set(handles.edit1,'Visible','off');
set(handles.text1,'Visible','off');
set(handles.text2,'Visible','off');
set(handles.text3,'Visible','off');

if ~isempty(varargin)
    ind =max(strcmp(list,varargin{1})' .* (1:length(list)));
    if(ind ~= 0)
        set(handles.popupmenu1,'value', ind); %posem l'element que ens passen per parametre com a seleccionat
        popupmenu1_Callback(hObject,eventdata,handles);
    end
end

function varargout = Menu_Editar_Dades2_OutputFcn(~, ~, handles) 
varargout{1} = handles.output;

function popupmenu1_Callback(~, ~, handles)
%recupero el nom de 'lobjecte que ha seleccionat l'usuari
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};
if ~strcmp(nom,'No DATA object in Workspace')
    
    
    
    

    aux = evalin('base',[nom '.copy();']); %en fem una copia per poder referir-nos a ell facilment
    
    nlots=aux.getBatchCount();
    
    if ~isempty(aux.getClass())
        set(handles.uitable1,'Data',aux.getClass());
    else
        set(handles.uitable1,'Data',zeros(1,nlots));
    end
    x=get(handles.uitable1,'Data');
    x = num2cell(x);
    
    if ~isempty(aux.getBatchLabel)
        x ={x{:} ;aux.getBatchLabel{:}}';
    else
        a=repmat({''},1,nlots);
        x ={x{:} ; a{:}}';
    end
    set(handles.uitable1,'Data',x)
    set(handles.uitable1,'Visible','on');
    set(handles.uitable1,'ColumnEditable',true(1,2));
    
    if ~isempty(aux.getVariableLabel)
        set(handles.uitable2,'Data',aux.getVariableLabel);
        set(handles.uitable2,'ColumnEditable',true(1,length(aux.getVariableLabel)));
        set(handles.uitable2,'Visible','on');
    else
        set(handles.uitable2,'Data',repmat({''},1,size(aux.getRawData3D,2)));
        set(handles.uitable2,'ColumnEditable',true(1,size(aux.getRawData3D,2)));
        set(handles.uitable2,'Visible','on');
    end
    
    a= aux.getStagesDurations;
    if isempty(a)
        set(handles.uitable3,'Data',{'',0})
        set(handles.uitable3,'Visible','on');
        set(handles.uitable3,'ColumnEditable',true(1,2));
    else
        set(handles.uitable3,'Data',a)
        x=get(handles.uitable3,'Data');
        x = num2cell(x);
        x ={aux.getStages{:} ; x{:} }';
        set(handles.uitable3,'Data',x)
        set(handles.uitable2,'ColumnEditable',true(1,2));
        set(handles.uitable3,'Visible','on');
    end
    set(handles.edit1,'String',aux.getName);
    
    set(handles.pushbutton5,'Visible','on');
    set(handles.pushbutton4,'Visible','on');
    set(handles.pushbutton3,'Visible','on');
    set(handles.pushbutton2,'Visible','on');
    set(handles.pushbutton1,'Visible','on');
    set(handles.edit1,'Visible','on');
    set(handles.text1,'Visible','on');
    set(handles.text2,'Visible','on');
    set(handles.text3,'Visible','on');
    
    set(handles.uitable1,'ColumnFormat',{'numeric', 'char'});
end

function popupmenu1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton1_Callback(hObject, ~, handles)
%recupero el nom de 'lobjecte que ha seleccionat l'usuari
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};

try
evalin('base', [nom '.setName(''' get(handles.edit1,'String') ''');'])

aux=get(handles.uitable1,'Data');

evalin('base', [nom '.setClass([' num2str([aux{:,1}]) ']);']);

assignin('base','var_Temp_aux',aux(:,2));
%evalin('base', 'global var_Temp_aux;');
evalin('base', [nom '.setBatchLabel(var_Temp_aux);']);

assignin('base','var_Temp_aux', get(handles.uitable2,'Data'));
evalin('base',[nom '.setVariableLabel(var_Temp_aux);']);

assignin('base','var_Temp_aux',get(handles.uitable3,'Data'));
evalin('base',[nom '.setStages(var_Temp_aux(:,1));']);

evalin('base',[nom '.setStagesDurations([var_Temp_aux{:,2}]);']);

evalin('base','clear var_Temp_aux;');
close('Menu_Editar_Dades2')
catch err
    errordlg(err.message,'Error');
    guidata(hObject, handles);
end

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(~, ~, handles)
a=get(handles.uitable3,'Data');
a(size(a,1)+1,1) = {''};
a(size(a,1),2) = {0};
set(handles.uitable3,'Data',a);
    set(handles.uitable2,'ColumnEditable',true(1,2));



function edit1_Callback(~, ~, ~)
function edit1_CreateFcn(hObject, ~, ~)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function pushbutton3_Callback(~, ~, handles)
%Classes des del WS
%busquem tots els objectes dades que hi hagi
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};


num = evalin('base',[nom '.getRawData3D();']);
num = size(num,3);%numero de lots

x=evalin('base','whos();');
list={};
for i=1:length(x)
    %si la variable es numerica i te les dimencions correctes per poder ser
    %les classes l'afegim a la llista si no no!
    if evalin('base', ['isnumeric(' x(i).name ')'] ) && (x(i).size(1) == 1 || x(i).size(2) == 1) && (x(i).size(1) == num || x(i).size(2) == num)
       list={list{:}; x(i).name()};%l'afegim!
    end
end

if isempty(list)
    warndlg('No variable in Workspace with correct size.','Attention!');
else
    num = listdlg('ListString',list,'SelectionMode','single','Name','Select','PromptString','select one variable:');
    if isempty(num)
        warndlg('No selected class vector!.','Attention!');

    else
        data=get(handles.uitable1,'Data');
        valors = evalin('base', list{num});
        for i =1:length(valors)
            data{i,1} = valors(i);
        end
        set(handles.uitable1,'Data',data);
    end
end
function pushbutton4_Callback(~, ~, handles)
%Noms de lots des del WS
%busquem tots els objectes dades que hi hagi
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};


num = evalin('base',[nom '.getRawData3D();']);
num = size(num,3);%numero de lots

x=evalin('base','whos();');
list={};
for i=1:length(x)
    %si la variable es numerica i te les dimencions correctes per poder ser
    %les classes l'afegim a la llista si no no!
    if evalin('base', ['iscellstr(' x(i).name ')'] ) && (x(i).size(1) == 1 || x(i).size(2) == 1) && (x(i).size(1) == num || x(i).size(2) == num)
       list={list{:}; x(i).name()};%l'afegim!
    end
end

if isempty(list)
    warndlg('No variable in Workspace with correct size or class.','Attention!');

else
    num = listdlg('ListString',list,'SelectionMode','single','Name','Select','PromptString','Select one variable:');
    if isempty(num)
        warndlg('No vector for reference is selected!','Atention!');

    else
        data=get(handles.uitable1,'Data');
        valors = evalin('base', list{num});
        for i =1:length(valors)
            data{i,2} = valors{i};
        end
        set(handles.uitable1,'Data',data);
    end
end

function pushbutton5_Callback(~, ~, handles)
%Noms de variables des de WS
%busquem tots els objectes dades que hi hagi
nom=get(handles.popupmenu1,'String');
nom=nom{get(handles.popupmenu1,'Value')};


num = evalin('base',[nom '.getVariableCount();']);

x=evalin('base','whos();');
list={};
for i=1:length(x)
    %si la variable es numerica i te les dimencions correctes per poder ser
    %les classes l'afegim a la llista si no no!
    if evalin('base', ['iscellstr(' x(i).name ')'] ) && (x(i).size(1) == 1 || x(i).size(2) == 1) && (x(i).size(1) == num || x(i).size(2) == num)
       list={list{:}; x(i).name()};%l'afegim!
    end
end

if isempty(list)
    warndlg('No variable in Workspace with correct size or class.','Attention!');

else
    num = listdlg('ListString',list,'SelectionMode','single','Name','Select','PromptString','select one variable:');
    if isempty(num)
        warndlg('No vector for names is selected!','Atention!');

    else
        %data=get(handles.uitable2,'Data');
        valors = evalin('base', list{num});
%         for i =1:length(valors)
%             data{i} = valors{i};
%         end
        set(handles.uitable2,'Data',valors);
    end
end
